AddCSLuaFile()

CreateConVar("beds_chatprint", "0", FCVAR_ARCHIVE, "Whether to print the messaage in chat to make it more obvious.", 0, 1)
CreateConVar("beds_hinttime", "3", FCVAR_ARCHIVE, "How long hints stay on the screen.", 1)

-- A list of received hint names, so we don't repeat them
local hints = {}

net.Receive("BedMessage", function()
	local str = net.ReadString()
	local typ = net.ReadUInt(4)
	local clr = net.ReadColor()
	local hintName = net.ReadString()
	
	if hintName and hintName ~= "" then
		if GetConVar("cl_showhints"):GetBool() == false then return end
		if hints[hintName] == true then return else hints[hintName] = true end
	end
	
	notification.AddLegacy(str, typ, GetConVar("beds_hinttime"):GetFloat() or 3)
	
	if GetConVar("beds_chatprint"):GetBool() then chat.AddText(Color(200, 200, 255), "[Spawn Beds] ", clr, str) 
	else MsgC(Color(200, 200, 255), "[Spawn Beds] ", clr, str .. "\n") end
end)

local function bed_options(cpanel)
    cpanel:AddControl("Header", {Description = "Client settings"})
	cpanel:AddControl("Slider", {Label = "Hint duration", Command = "beds_hinttime", Min = 1, Max = 10, Type = "float" })
    cpanel:AddControl("Checkbox", {Label = "Print messages to chat", Command = "beds_chatprint" })
	cpanel:AddControl("Header", {Description = ""})
	cpanel:AddControl("Header", {Description = "Server settings"})
	cpanel:AddControl("Slider", {Label = "Damage scale", Command = "beds_damagescale", Min = 0, Max = 2, Type = "float" })
	cpanel:AddControl("Slider", {Label = "Respawn delay scale", Command = "beds_timescale", Min = 0, Max = 2, Type = "float" })
	cpanel:AddControl("Checkbox", {Label = "Beds must be indoors (except sleeping bags)", Command = "beds_indoors" })
	cpanel:AddControl("Checkbox", {Label = "Only world counts for walls/ceilings", Command = "beds_indoors_worldonly" })
	cpanel:AddControl("Slider", {Label = "Wall check count", Command = "beds_indoors_wallcount", Min = 1, Max = 4, Type = "int" })
	cpanel:AddControl("Slider", {Label = "Maximum wall distance", Command = "beds_indoors_walldist", Min = 512, Max = 4096, Type = "int" })
	cpanel:AddControl("Checkbox", {Label = "Admin-only Custom Beds", Command = "beds_custom_adminonly" })
end

hook.Add( "PopulateToolMenu", "bed_options", function()
    spawnmenu.AddToolMenuOption( "Options", "Spawn Beds", "", "Options", "", "", bed_options)
end )