AddCSLuaFile()

ENT.Type = "anim"
ENT.PrintName = "Bed"
ENT.Author = "8Z"
ENT.Spawnable = false

ENT.Model = "models/props_c17/FurnitureBed001a.mdl"
ENT.ModelOffset = Vector(0,0,0)
ENT.AngleOffset = Angle(0,0,0)
ENT.SpawnDelay = 30
ENT.Mass = nil
-- Setting this to a Vector here will freak out on any entities using it as a Table of Vectors
-- We simply have to assume it exists
ENT.BedSpawnOffset = nil 
ENT.NeedIndoors = true
ENT.TwoSides = true

ENT.DrawBed = true
ENT.MattressModel = nil
ENT.MattressOffset = Vector(0,0,-5)
ENT.MattressAngles = Angle(0,0,0)

ENT.MaxHealth = 100

function ENT:SetupDataTables()
	self:NetworkVar("Entity", 0, "BedOwner")
end

if SERVER then 
	
	function ENT:SpawnFunction( ply, tr, ClassName )

		if ( !tr.Hit ) then return end
		local ent = ents.Create( ClassName )
		ent:SetAngles(ply:GetAngles() - Angle(0,180,0) + (ent.AngleOffset or Angle(0,0,0)))
		ent:SetPos(tr.HitPos + tr.HitNormal * 4 + ent:GetModelOffset())
		ent:Spawn()
		ent:Activate()
		
		return ent

	end

	function ENT:Initialize()
		self:SetModel(self.Model)
		if self.Material then self:SetMaterial(self.Material) end
		if self.CustomBounds then
			self:PhysicsInitBox(self.CustomBounds[1], self.CustomBounds[2])
		else
			self:PhysicsInit(SOLID_VPHYSICS)
		end
		self:SetMoveType(MOVETYPE_VPHYSICS)
		self:SetSolid(SOLID_VPHYSICS)
		self:DrawShadow(self.DrawBed)
		self:SetCollisionGroup(COLLISION_GROUP_NONE)
		self:SetUseType(SIMPLE_USE)
		timer.Simple(0, function()
			if IsValid(self) and IsValid(self:GetPhysicsObject()) then
				if self.Mass then self:GetPhysicsObject():SetMass(self.Mass) end
				self:GetPhysicsObject():Wake()
			end
		end)
		self:SetMaxHealth(self.MaxHealth)
		self:SetHealth(self.MaxHealth)
		self.LastDamage = CurTime()
	end
	
	function ENT:AngleCheck()
		local dot = (self:GetAngles():Up()):Dot(Vector(0,0,1))
		if self.TwoSides then
			return math.abs(dot) < 0.6
		else
			return dot < 0.6
		end
	end

	function ENT:CollisionCheck()
		local tbl = istable(self.BedSpawnOffset) and self.BedSpawnOffset or self.BedSpawnOffset and {self.BedSpawnOffset}
		
		for k, v in pairs(tbl) do
			local offset = self:GetBedSpawnOffset(k)
			local tr = util.TraceHull({
				start = self:GetPos() + offset,
				endpos = self:GetPos() + offset + Vector(0,0,16),
				maxs = Vector(16,16,72),
				mins = Vector(-16,-16,0),
				mask = MASK_PLAYERSOLID,
				filter = self:GetBedOwner(),
			})
			if not tr.Hit then return false, k end
		end
		return true
	end
	
	function ENT:IndoorCheck()
		if not self.NeedIndoors then return false end
		if not GetConVar("beds_indoors"):GetBool() then return false end
		local m = GetConVar("beds_indoors_worldonly"):GetBool() and MASK_SOLID_BRUSHONLY or MASK_SOLID
		
		local tr = util.TraceLine({
			start = self:GetPos(),
			endpos = self:GetPos() + Vector(0,0,50000),
			filter = self,
			mask = m
		})
		if tr.HitSky or not tr.Hit then return true end
		
		if GetConVar("beds_indoors_wallcount"):GetInt() == 0 then return false end
		
		local len = GetConVar("beds_indoors_walldist"):GetInt()
		local vectors = {Vector(len, 0, 0), Vector(-len, 0, 0), Vector(0, len, 0), Vector(0, -len, 0)}
		local walls = 0
		for _, v in pairs(vectors) do
			local tr = util.TraceLine({
				start = self:GetPos(),
				endpos = self:GetPos() + v,
				filter = self,
				mask = m
			})
			if tr.Hit and not tr.HitSky then walls = walls + 1 end
		end
		return walls < GetConVar("beds_indoors_wallcount"):GetInt()
	end
	
	function ENT:Use(activator)
		if IsValid(self:GetBedOwner()) then
			if self:GetBedOwner() == activator then
				BedMessage(activator, "This bed is no longer your spawnpoint.")
				activator:SendLua('surface.PlaySound("garrysmod/ui_return.wav")')
				self.Owner = nil
				self:SetBedOwner(nil)
				activator.SpawnBed = nil
			else
				BedMessage(activator, "This bed belongs to " .. self:GetBedOwner():GetName() .. ".")
			end
		else
			if IsValid(activator.SpawnBed) then
				activator.SpawnBed.Owner = nil
				activator.SpawnBed:SetBedOwner(nil)
				activator.SpawnBed = nil
			end
			self.Owner = activator
			self:SetBedOwner(activator)
			activator.SpawnBed = self
			activator:SendLua('surface.PlaySound("garrysmod/ui_click.wav")')
			BedMessage(activator, "This bed is now your spawnpoint.")
			timer.Simple(0.5, function() 
				if IsValid(self) then
					if self:CollisionCheck() and not self:AngleCheck() then
						BedMessage(activator, "Some obstruction seems to exist. You must clear the bed or you can't spawn here.", 3, Color(255,200,0))
					end
					if self:AngleCheck() then
						BedMessage(activator, "The bed seems to be tilted/flipped. You must set it upright or you can't spawn here.", 3, Color(255,200,0))
					end
					if self:IndoorCheck() then
						BedMessage(activator, "The bed seems to be outdoors. You must set it under a roof and between some walls.", 3, Color(255,200,0))
					end
				end 
			end)
		end
	end
	
	function ENT:OnTakeDamage(dmginfo)
	
		if self.MaxHealth <= 0 or GetConVar("beds_damagescale"):GetFloat() <= 0 then -- Invincible
			self:TakePhysicsDamage(dmginfo) 
			return
		end
	
		local scale = {
			[DMG_BURN] = 3,
			[DMG_BULLET] = 0.25,
			[DMG_BLAST] = 1.5,
		}
		for typ, v in pairs(scale) do
			if dmginfo:IsDamageType(typ) then dmginfo:ScaleDamage(v) end
		end
		dmginfo:ScaleDamage(GetConVar("beds_damagescale"):GetFloat())
		
		local damage = dmginfo:GetDamage()
		self:TakePhysicsDamage(dmginfo)
		self:SetHealth(self:Health() - damage)
		if self:Health() <= 0 then
			self:EmitSound("physics/wood/wood_box_break1.wav", 90, 110)
			self:Remove()
		else
			self.LastHit = CurTime()
		end
	end
	
	function ENT:Think()
		if self:Health() < self:GetMaxHealth() and self.LastHit and self.LastHit + 10 < CurTime() then
			self:SetHealth(math.min(self:GetMaxHealth(), math.Round(self:Health() + self:GetMaxHealth() * 0.1)))
			self:NextThink(CurTime() + 1)
			return true
		end
	end
	
	function ENT:OnRemove()
		if IsValid(self:GetBedOwner()) then
			self:GetBedOwner().SpawnBed = false
		end
	end
	
	hook.Add("PlayerSpawn", "SpawnBeds", function(ply)
		if IsValid(ply.SpawnBed) then
			local ent = ply.SpawnBed
			ply.NextBedSpawn = ply.NextBedSpawn or 0
			
			if ply.NextBedSpawn > CurTime() then
				BedMessage(ply, "You cannot spawn in a bed for another " .. math.ceil(ply.NextBedSpawn - CurTime()) .. " second(s).", 1, Color(255,100,100))
				return
			end
			if ent:CollisionCheck() then
				BedMessage(ply, "You couldn't spawn in your bed because it is obstructed.", 1, Color(255,100,100))
				return
			end
			if ent:AngleCheck() then
				BedMessage(ply, "You couldn't spawn in your bed because it is tilted or flipped over.", 1, Color(255,100,100))
				return
			end
			if ent:IndoorCheck() then
				BedMessage(ply, "You couldn't spawn in your bed because it is not indoors.", 1, Color(255,100,100))
				return
			end
			ply:SetPos(ent:GetSpawnPos())
			local ang = ent:GetAngles()
			ang:RotateAroundAxis(ent:GetAngles():Forward(), ent.AngleOffset.p)
			ang:RotateAroundAxis(ent:GetAngles():Up(), ent.AngleOffset.y)
			ang:RotateAroundAxis(ent:GetAngles():Right(), ent.AngleOffset.r)
			ang.r = 0
			ply:SetEyeAngles(ang)
			local t = ent.SpawnDelay * GetConVar("beds_timescale"):GetFloat()
			ply.NextBedSpawn = CurTime() + t
			if t > 0 then
				BedMessage(ply, "You will be able to spawn in a bed again in " .. math.ceil(t) .. " seconds.")
			end
		elseif ply.SpawnBed == false then
			BedMessage(ply, "You couldn't spawn in your bed because it was destroyed or removed.", 1, Color(255,100,100))
			ply.SpawnBed = nil
			return
		end
	end)
end

if CLIENT then

	function ENT:Initialize()
	
		if not self.MattressModel or self.MattressModel == "" then return end
		self.Mattress = ClientsideModel(self.MattressModel)
		self.Mattress:SetPos(self:GetPos() + self:GetAngles():Forward() * self.MattressOffset.x
			+ self:GetAngles():Right() * self.MattressOffset.y
			+ self:GetAngles():Up() * self.MattressOffset.z)
		local ang = self:GetAngles()
		ang:RotateAroundAxis(self:GetAngles():Forward(), self.MattressAngles.p)
		ang:RotateAroundAxis(self:GetAngles():Up(), self.MattressAngles.y)
		ang:RotateAroundAxis(self:GetAngles():Right(), self.MattressAngles.r)
		self.Mattress:SetAngles(ang)
		self.Mattress:SetParent(self)
		if self.MattressScale then
			local matrix = Matrix()
			matrix:Scale(self.MattressScale)
			self.Mattress:EnableMatrix("RenderMultiply", matrix)
		end
	end
	
	function ENT:OnRemove()
		if IsValid(self.Mattress) then self.Mattress:Remove() end
	end
	
	function ENT:Draw()
		if self.DrawBed ~= false then
			self:DrawModel()
		end
		if IsValid(self.Mattress) then
			self.Mattress:SetPos(self:GetPos() + self:GetAngles():Forward() * self.MattressOffset.x
				+ self:GetAngles():Right() * self.MattressOffset.y
				+ self:GetAngles():Up() * self.MattressOffset.z)
			local ang = self:GetAngles()
			ang:RotateAroundAxis(self:GetAngles():Forward(), self.MattressAngles.p)
			ang:RotateAroundAxis(self:GetAngles():Up(), self.MattressAngles.y)
			ang:RotateAroundAxis(self:GetAngles():Right(), self.MattressAngles.r)
			self.Mattress:SetAngles(ang)
		end
	end
	
	function ENT:BeingLookedAtByLocalPlayer()
		local ply = LocalPlayer()
		if ( !IsValid( ply ) ) then return false end

		local view = ply:GetViewEntity()
		local dist = 256 --self.MaxWorldTipDistance
		dist = dist * dist

		-- If we're spectating a player, perform an eye trace
		if ( view:IsPlayer() ) then
			return view:EyePos():DistToSqr( self:GetPos() ) <= dist && view:GetEyeTrace().Entity == self
		end

		-- If we're not spectating a player, perform a manual trace from the entity's position
		local pos = view:GetPos()

		if ( pos:DistToSqr( self:GetPos() ) <= dist ) then
			return util.TraceLine( {
				start = pos,
				endpos = pos + ( view:GetAngles():Forward() * dist ),
				filter = view
			} ).Entity == self
		end

		return false
	end
	
	function ENT:Think()
		local text = self:GetOverlayText()

		if ( text != "" && self:BeingLookedAtByLocalPlayer() ) then
			AddWorldTip( nil, text, nil, self:WorldSpaceCenter() )

			--halo.Add( { self }, color_white, 1, 1, 1, true, true )
		end
	end

	function ENT:GetOverlayText()

		local text = self.PrintName
		if IsValid(self:GetBedOwner()) then
			text = self:GetBedOwner():GetName() .. "'s " .. text
		end

		return text
	end

end

function ENT:GetModelOffset()
	if not self.ModelOffset then return Vector(0,0,0) end
	return self:GetAngles():Forward() * self.ModelOffset.x 
			+ self:GetAngles():Right() * self.ModelOffset.y
			+ self:GetAngles():Up() * self.ModelOffset.z
end

function ENT:GetSpawnPos()
	local chk, index = self:CollisionCheck()
	if chk == true then return nil end
	return self:GetPos() + self:GetBedSpawnOffset(index)
end

function ENT:GetBedSpawnOffset(i)
	local vec = self.BedSpawnOffset
	if istable(self.BedSpawnOffset) then vec = self.BedSpawnOffset[i or 1] end
	return self:GetAngles():Forward() * vec.x 
			+ self:GetAngles():Right() * vec.y
			+ self:GetAngles():Up() * vec.z
end